<?php

namespace Liberty\Services\Emisor\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for tarjetaCreditoPat StructType
 * @subpackage Structs
 */
class TarjetaCreditoPat extends AbstractStructBase
{
    /**
     * The cantidadCuotasPat
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $cantidadCuotasPat;
    /**
     * The diaPagoPat
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $diaPagoPat;
    /**
     * The emisorPat
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $emisorPat;
    /**
     * The fechaExpiracionPat
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $fechaExpiracionPat;
    /**
     * The fechaPrimeraCuotaPat
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $fechaPrimeraCuotaPat;
    /**
     * The mailTitularPat
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $mailTitularPat;
    /**
     * The montoContado
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var float
     */
    public $montoContado;
    /**
     * The montoPat
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var float
     */
    public $montoPat;
    /**
     * The numeroTarjetaPat
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $numeroTarjetaPat;
    /**
     * The porcContado
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var float
     */
    public $porcContado;
    /**
     * The rutDvTitularPat
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $rutDvTitularPat;
    /**
     * The rutTitularPat
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $rutTitularPat;
    /**
     * The tasaInteresPat
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var float
     */
    public $tasaInteresPat;
    /**
     * The tipoTarjetaPat
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $tipoTarjetaPat;
    /**
     * Constructor method for tarjetaCreditoPat
     * @uses TarjetaCreditoPat::setCantidadCuotasPat()
     * @uses TarjetaCreditoPat::setDiaPagoPat()
     * @uses TarjetaCreditoPat::setEmisorPat()
     * @uses TarjetaCreditoPat::setFechaExpiracionPat()
     * @uses TarjetaCreditoPat::setFechaPrimeraCuotaPat()
     * @uses TarjetaCreditoPat::setMailTitularPat()
     * @uses TarjetaCreditoPat::setMontoContado()
     * @uses TarjetaCreditoPat::setMontoPat()
     * @uses TarjetaCreditoPat::setNumeroTarjetaPat()
     * @uses TarjetaCreditoPat::setPorcContado()
     * @uses TarjetaCreditoPat::setRutDvTitularPat()
     * @uses TarjetaCreditoPat::setRutTitularPat()
     * @uses TarjetaCreditoPat::setTasaInteresPat()
     * @uses TarjetaCreditoPat::setTipoTarjetaPat()
     * @param int $cantidadCuotasPat
     * @param int $diaPagoPat
     * @param string $emisorPat
     * @param int $fechaExpiracionPat
     * @param int $fechaPrimeraCuotaPat
     * @param string $mailTitularPat
     * @param float $montoContado
     * @param float $montoPat
     * @param int $numeroTarjetaPat
     * @param float $porcContado
     * @param string $rutDvTitularPat
     * @param int $rutTitularPat
     * @param float $tasaInteresPat
     * @param string $tipoTarjetaPat
     */
    public function __construct($cantidadCuotasPat = null, $diaPagoPat = null, $emisorPat = null, $fechaExpiracionPat = null, $fechaPrimeraCuotaPat = null, $mailTitularPat = null, $montoContado = null, $montoPat = null, $numeroTarjetaPat = null, $porcContado = null, $rutDvTitularPat = null, $rutTitularPat = null, $tasaInteresPat = null, $tipoTarjetaPat = null)
    {
        $this
            ->setCantidadCuotasPat($cantidadCuotasPat)
            ->setDiaPagoPat($diaPagoPat)
            ->setEmisorPat($emisorPat)
            ->setFechaExpiracionPat($fechaExpiracionPat)
            ->setFechaPrimeraCuotaPat($fechaPrimeraCuotaPat)
            ->setMailTitularPat($mailTitularPat)
            ->setMontoContado($montoContado)
            ->setMontoPat($montoPat)
            ->setNumeroTarjetaPat($numeroTarjetaPat)
            ->setPorcContado($porcContado)
            ->setRutDvTitularPat($rutDvTitularPat)
            ->setRutTitularPat($rutTitularPat)
            ->setTasaInteresPat($tasaInteresPat)
            ->setTipoTarjetaPat($tipoTarjetaPat);
    }
    /**
     * Get cantidadCuotasPat value
     * @return int|null
     */
    public function getCantidadCuotasPat()
    {
        return $this->cantidadCuotasPat;
    }
    /**
     * Set cantidadCuotasPat value
     * @param int $cantidadCuotasPat
     * @return \Liberty\Services\Emisor\StructType\TarjetaCreditoPat
     */
    public function setCantidadCuotasPat($cantidadCuotasPat = null)
    {
        // validation for constraint: int
        if (!is_null($cantidadCuotasPat) && !(is_int($cantidadCuotasPat) || ctype_digit($cantidadCuotasPat))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($cantidadCuotasPat, true), gettype($cantidadCuotasPat)), __LINE__);
        }
        $this->cantidadCuotasPat = $cantidadCuotasPat;
        return $this;
    }
    /**
     * Get diaPagoPat value
     * @return int|null
     */
    public function getDiaPagoPat()
    {
        return $this->diaPagoPat;
    }
    /**
     * Set diaPagoPat value
     * @param int $diaPagoPat
     * @return \Liberty\Services\Emisor\StructType\TarjetaCreditoPat
     */
    public function setDiaPagoPat($diaPagoPat = null)
    {
        // validation for constraint: int
        if (!is_null($diaPagoPat) && !(is_int($diaPagoPat) || ctype_digit($diaPagoPat))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($diaPagoPat, true), gettype($diaPagoPat)), __LINE__);
        }
        $this->diaPagoPat = $diaPagoPat;
        return $this;
    }
    /**
     * Get emisorPat value
     * @return string|null
     */
    public function getEmisorPat()
    {
        return $this->emisorPat;
    }
    /**
     * Set emisorPat value
     * @param string $emisorPat
     * @return \Liberty\Services\Emisor\StructType\TarjetaCreditoPat
     */
    public function setEmisorPat($emisorPat = null)
    {
        // validation for constraint: string
        if (!is_null($emisorPat) && !is_string($emisorPat)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($emisorPat, true), gettype($emisorPat)), __LINE__);
        }
        $this->emisorPat = $emisorPat;
        return $this;
    }
    /**
     * Get fechaExpiracionPat value
     * @return int|null
     */
    public function getFechaExpiracionPat()
    {
        return $this->fechaExpiracionPat;
    }
    /**
     * Set fechaExpiracionPat value
     * @param int $fechaExpiracionPat
     * @return \Liberty\Services\Emisor\StructType\TarjetaCreditoPat
     */
    public function setFechaExpiracionPat($fechaExpiracionPat = null)
    {
        // validation for constraint: int
        if (!is_null($fechaExpiracionPat) && !(is_int($fechaExpiracionPat) || ctype_digit($fechaExpiracionPat))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($fechaExpiracionPat, true), gettype($fechaExpiracionPat)), __LINE__);
        }
        $this->fechaExpiracionPat = $fechaExpiracionPat;
        return $this;
    }
    /**
     * Get fechaPrimeraCuotaPat value
     * @return int|null
     */
    public function getFechaPrimeraCuotaPat()
    {
        return $this->fechaPrimeraCuotaPat;
    }
    /**
     * Set fechaPrimeraCuotaPat value
     * @param int $fechaPrimeraCuotaPat
     * @return \Liberty\Services\Emisor\StructType\TarjetaCreditoPat
     */
    public function setFechaPrimeraCuotaPat($fechaPrimeraCuotaPat = null)
    {
        // validation for constraint: int
        if (!is_null($fechaPrimeraCuotaPat) && !(is_int($fechaPrimeraCuotaPat) || ctype_digit($fechaPrimeraCuotaPat))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($fechaPrimeraCuotaPat, true), gettype($fechaPrimeraCuotaPat)), __LINE__);
        }
        $this->fechaPrimeraCuotaPat = $fechaPrimeraCuotaPat;
        return $this;
    }
    /**
     * Get mailTitularPat value
     * @return string|null
     */
    public function getMailTitularPat()
    {
        return $this->mailTitularPat;
    }
    /**
     * Set mailTitularPat value
     * @param string $mailTitularPat
     * @return \Liberty\Services\Emisor\StructType\TarjetaCreditoPat
     */
    public function setMailTitularPat($mailTitularPat = null)
    {
        // validation for constraint: string
        if (!is_null($mailTitularPat) && !is_string($mailTitularPat)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($mailTitularPat, true), gettype($mailTitularPat)), __LINE__);
        }
        $this->mailTitularPat = $mailTitularPat;
        return $this;
    }
    /**
     * Get montoContado value
     * @return float|null
     */
    public function getMontoContado()
    {
        return $this->montoContado;
    }
    /**
     * Set montoContado value
     * @param float $montoContado
     * @return \Liberty\Services\Emisor\StructType\TarjetaCreditoPat
     */
    public function setMontoContado($montoContado = null)
    {
        // validation for constraint: float
        if (!is_null($montoContado) && !(is_float($montoContado) || is_numeric($montoContado))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($montoContado, true), gettype($montoContado)), __LINE__);
        }
        $this->montoContado = $montoContado;
        return $this;
    }
    /**
     * Get montoPat value
     * @return float|null
     */
    public function getMontoPat()
    {
        return $this->montoPat;
    }
    /**
     * Set montoPat value
     * @param float $montoPat
     * @return \Liberty\Services\Emisor\StructType\TarjetaCreditoPat
     */
    public function setMontoPat($montoPat = null)
    {
        // validation for constraint: float
        if (!is_null($montoPat) && !(is_float($montoPat) || is_numeric($montoPat))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($montoPat, true), gettype($montoPat)), __LINE__);
        }
        $this->montoPat = $montoPat;
        return $this;
    }
    /**
     * Get numeroTarjetaPat value
     * @return int|null
     */
    public function getNumeroTarjetaPat()
    {
        return $this->numeroTarjetaPat;
    }
    /**
     * Set numeroTarjetaPat value
     * @param int $numeroTarjetaPat
     * @return \Liberty\Services\Emisor\StructType\TarjetaCreditoPat
     */
    public function setNumeroTarjetaPat($numeroTarjetaPat = null)
    {
        // validation for constraint: int
        if (!is_null($numeroTarjetaPat) && !(is_int($numeroTarjetaPat) || ctype_digit($numeroTarjetaPat))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($numeroTarjetaPat, true), gettype($numeroTarjetaPat)), __LINE__);
        }
        $this->numeroTarjetaPat = $numeroTarjetaPat;
        return $this;
    }
    /**
     * Get porcContado value
     * @return float|null
     */
    public function getPorcContado()
    {
        return $this->porcContado;
    }
    /**
     * Set porcContado value
     * @param float $porcContado
     * @return \Liberty\Services\Emisor\StructType\TarjetaCreditoPat
     */
    public function setPorcContado($porcContado = null)
    {
        // validation for constraint: float
        if (!is_null($porcContado) && !(is_float($porcContado) || is_numeric($porcContado))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($porcContado, true), gettype($porcContado)), __LINE__);
        }
        $this->porcContado = $porcContado;
        return $this;
    }
    /**
     * Get rutDvTitularPat value
     * @return string|null
     */
    public function getRutDvTitularPat()
    {
        return $this->rutDvTitularPat;
    }
    /**
     * Set rutDvTitularPat value
     * @param string $rutDvTitularPat
     * @return \Liberty\Services\Emisor\StructType\TarjetaCreditoPat
     */
    public function setRutDvTitularPat($rutDvTitularPat = null)
    {
        // validation for constraint: string
        if (!is_null($rutDvTitularPat) && !is_string($rutDvTitularPat)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($rutDvTitularPat, true), gettype($rutDvTitularPat)), __LINE__);
        }
        $this->rutDvTitularPat = $rutDvTitularPat;
        return $this;
    }
    /**
     * Get rutTitularPat value
     * @return int|null
     */
    public function getRutTitularPat()
    {
        return $this->rutTitularPat;
    }
    /**
     * Set rutTitularPat value
     * @param int $rutTitularPat
     * @return \Liberty\Services\Emisor\StructType\TarjetaCreditoPat
     */
    public function setRutTitularPat($rutTitularPat = null)
    {
        // validation for constraint: int
        if (!is_null($rutTitularPat) && !(is_int($rutTitularPat) || ctype_digit($rutTitularPat))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($rutTitularPat, true), gettype($rutTitularPat)), __LINE__);
        }
        $this->rutTitularPat = $rutTitularPat;
        return $this;
    }
    /**
     * Get tasaInteresPat value
     * @return float|null
     */
    public function getTasaInteresPat()
    {
        return $this->tasaInteresPat;
    }
    /**
     * Set tasaInteresPat value
     * @param float $tasaInteresPat
     * @return \Liberty\Services\Emisor\StructType\TarjetaCreditoPat
     */
    public function setTasaInteresPat($tasaInteresPat = null)
    {
        // validation for constraint: float
        if (!is_null($tasaInteresPat) && !(is_float($tasaInteresPat) || is_numeric($tasaInteresPat))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($tasaInteresPat, true), gettype($tasaInteresPat)), __LINE__);
        }
        $this->tasaInteresPat = $tasaInteresPat;
        return $this;
    }
    /**
     * Get tipoTarjetaPat value
     * @return string|null
     */
    public function getTipoTarjetaPat()
    {
        return $this->tipoTarjetaPat;
    }
    /**
     * Set tipoTarjetaPat value
     * @param string $tipoTarjetaPat
     * @return \Liberty\Services\Emisor\StructType\TarjetaCreditoPat
     */
    public function setTipoTarjetaPat($tipoTarjetaPat = null)
    {
        // validation for constraint: string
        if (!is_null($tipoTarjetaPat) && !is_string($tipoTarjetaPat)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($tipoTarjetaPat, true), gettype($tipoTarjetaPat)), __LINE__);
        }
        $this->tipoTarjetaPat = $tipoTarjetaPat;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \Liberty\Services\Emisor\StructType\TarjetaCreditoPat
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
